/*
 * (c) Copyright 1988 by
 * Robotics Principles Research Department, ATT Bell Laboratories.
 * All rights reserved.
 * Last modified 2/8/88 Ingemar J. Cox
 * C version 8/2/88 Deborah A. Wallach
 */

#define abs(x) ((x)<0 ? -(x) : (x))
#define max(x, y) ((x)>(y) ? (x) : (y))
#define min(x, y) ((x)<(y) ? (x) : (y))

#define EDGE_X 1
#define EDGE_Y 2
#define EDGE_45 3
#define EDGE_135 4

#define FWD 0
#define BWD 1

#define diag_scale 1.414 /* scale factor for diagonals */

struct image
{
	unsigned char *an_image; /* pointer to image array */
	int nx, ny; /* dimensions of image array */

	int*	gaussian; /* pointer to output image after convolution */
	int *idx, *idy, *id45, *id135; /* pointers to o/p from detn filters */

	int *filter; /* pointer to 1D array of filter coefficients */
	int norm; /* normalization factor after convolution */
	int nf, nf2; /* nf = size of filter (in pixels), nf2=nf/2 */
	int orient_flag;
	unsigned char *edge_map, *edge_map_hi;
	int lo_threshold;
};



